#ifndef n_cReactiveEngine_H
#define n_cReactiveEngine_H

/*
 *
 * nucleo/core/carbon/cReactiveEngine.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/core/ReactiveEngine.H>

#include <queue>

#include <Carbon/Carbon.h>

namespace nucleo {

  class cReactiveEngine : public ReactiveEngineImplementation {

  private:

    std::queue<ReactivePair> _objectsToNotify ;

    friend class ReactiveEngine ;

    cReactiveEngine(void) ;
    static OSStatus cb(EventHandlerCallRef, EventRef, void*) ;

  public:
    
    ~cReactiveEngine(void) ;

    void notify(ReactiveObject *notified, Observable *notifier) ;

    int step(long milliseconds=-1) ;

    void run(void) ;
    void stop(void) ;

  } ;

}

#endif
